﻿from pyplasm import *

"""
DEF link = (T:<1,2>:<-1,-19> ∼ CUBOID):<2,20>
DEF joint (alpha::IsReal) = T:2:-18 ∼ R:<1,2>:(alpha * PI/180);
DEF arm (a1,a2,a3::IsReal) =
STRUCT: < link, joint:a1, link, joint:a2, link, joint:a3, link >;

DEF Sampling (n::IsInt) = (AA:/ ∼ DISTR):< 0..n, n >;
"""

link = SKELETON(1)(T([1,2])([-1,-19])(CUBOID([2,20])))

def joint (alpha): return [ T(2)(-18), R([1,2])(alpha * PI/180)]

def arm (args):
    a1,a2,a3 = args
    return STRUCT( [link] + joint(a1) + [link] +
                    joint(a2) + [link] + joint(a3) + [link] )

VIEW(arm ([30,0,0]))


def sampling(n): return AA(DIV)(DISTR([range(n+1),n]))

def sample (n):
    return AA(SCALARVECTPROD)(DISTL([[90,90,90], sampling(n)]))


VIEW(STRUCT(AA(arm)(sample(10))))
